#ifndef NDS_CONSOLE_H
#define NDS_CONSOLE_H

#include <nds/jtypes.h>
#define CONSOLE_WIDTH 32
#define CONSOLE_HEIGHT 24

/*---------------------------------------------------------------------------------
	consoleInit
	param:
		font: 16 color font
		charBase: the location the font data will be loaded to
		numCharacters: count of characters in the font
		charStart: The ascii number of the first character in the font set
					if you have a full set this will be zero
		map: pointer to the map you will be printing to.
		pal: specifies the 16 color palette to use, if > 15 it will change all non-zero
			entries in the font to use palette index 255
---------------------------------------------------------------------------------*/
void consoleInitJis(u16* font, u16* charBase, u16* charEnd,
		    u16 numCharacters, u8 charStart,
		    u16* fontJis,
		    u16 numCharactersJis, u8 charStartJis,
		    u16* map, u8 pal, u8 bitDepth);
//---------------------------------------------------------------------------------
// Places the console in a default mode using bg0 of the sub display, and vram c for 
// font and map..this is provided for rapid prototyping and nothing more
void consoleDemoInitJis(void);
void consoleInitDefaultJis(u16* map, u16* charBase, u16* charEnd, u8 bitDepth);
#endif
